Subject: bug#70311: closed (Re: bug#70311: Crash when dnd-indicate-insertion-point is non-nil)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 14 Apr 2024 10:19:14 +0000

Your bug report

#70311: Crash when dnd-indicate-insertion-point is non-nil

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
70311: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=70311
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#70311: Crash when dnd-indicate-insertion-point is non-nil
From: Eli Zaretskii <[email-masked]>
To: Po Lu <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Sun, 14 Apr 2024 13:17:37 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Po Lu <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Sun, 14 Apr 2024 17:24:12 +0800
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> From: Po Lu <[email-masked]>
> >> Cc: [email-masked],  [email-masked]
> >> Date: Sat, 13 Apr 2024 20:28:14 +0800
> >> 
> >> Eli Zaretskii <[email-masked]> writes:
> >> 
> >> > So you think the suggested band-aid is the best we can currently do to
> >> > prevent crashes in those cases?
> >> 
> >> Yes, unfortunately.
> >
> > Does the band-aid below look OK to you?
> >
> > diff --git a/lisp/dnd.el b/lisp/dnd.el
> > index 89652d3..de1c58a 100644
> > --- a/lisp/dnd.el
> > +++ b/lisp/dnd.el
> > @@ -149,8 +149,13 @@ dnd-handle-movement
> >                  (with-selected-window window
> >                    (scroll-down 1))))))))
> >        (when dnd-indicate-insertion-point
> > -        (ignore-errors
> > -          (goto-char (posn-point posn)))))))
> > +        (let ((pos (posn-point posn)))
> > +          ;; We avoid errors here, since on some systems this runs
> > +          ;; when waiting_for_input is non-zero, and that aborts on
> > +          ;; error.
> > +          (if (and pos (<= (point-min) pos (point-max)))
> > +              (goto-char pos)
> > +            pos))))))
> 
> Yes, please install.  Thanks.

Thanks, installed on the emacs-29 branch, and closing the bug.

Subject: Crash when dnd-indicate-insertion-point is non-nil
From: Greg Sexton <[email-masked]>
To: [email-masked]
Date: Tue, 9 Apr 2024 11:26:41 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Emacs (29.1.90) can crash on Mac OS X when dnd-indicate-insertion-point
is non-nil.

I'm not able to deterministically reproduce this, but I have a high
success rate dragging a file over the window and just randomly moving
it around without releasing the click.

This said, I attached a debugger and found the root cause.

There is code that looks like this in dnd-handle-movement:

  (when dnd-indicate-insertion-point
     (ignore-errors
       (goto-char (posn-point posn))))

posn-point can return nil, which causes goto-char to call
wrong_type_argument, this reaches signal_or_quit (eval.c), which calls
emacs_abort as waiting_for_input is true.

A quick fix might be to when-let the result of posn-point, but I'm
unsure if waiting_for_input being true points to a deeper issue.

--

Greg